﻿class vector extends point{
	function vector(xx:Number, yy:Number){
		x = xx;
		y = yy;
	}
	
	function duplicate(vv:vector):vector{
		var v:vector = new vector(vv.x, vv.y);
		return v;
	}

	function sum(vv:vector):vector{
		var v:vector = new vector(vv.x, vv.y);
		v.x += x;
		v.y += y;
		return v;
	}
	
	function dot(vv:vector):Number{
		var n:Number = vv.x * x + vv.y * y;
		return n;	
	}
	
	function mag():Number{
		return Math.sqrt(x * x + y * y);
	}
	
	function angleBetween(vv:vector):Number{
		var n:Number = vv.dot(this)/(this.mag() * vv.mag());
		return Math.acos(n) * (180/Math.PI);
	}
	
	function dump(){
		return ("[" + x + ", " + y + "]");
	}	
}